Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.21
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.jce.cert
Class CertPathBuilder

    java.lang.Object
      |
      +--org.bouncycastle.jce.cert.CertPathBuilder

public class CertPathBuilder
extends java.lang.Object

A class for building certification paths (also known as certificate chains).
This class uses a provider-based architecture, as described in the Java Cryptography Architecture. To create a `CertPathBuilder`, call one of the static `getInstance` methods, passing in the algorithm name of the CertPathBuilder desired and optionally the name of the provider desired.
Once a `CertPathBuilder` object has been created, certification paths can be constructed by calling the `build` method and passing it an algorithm-specific set of parameters. If successful, the result (including the CertPath that was built) is returned in an object that implements the `CertPathBuilderResult` interface.
Concurrent Access
The static methods of this class are guaranteed to be thread-safe. Multiple threads may concurrently invoke the static methods defined in this class with no ill effects.
However, this is not true for the non-static methods defined by this class. Unless otherwise documented by a specific provider, threads that need to access a single `CertPathBuilder` instance concurrently should synchronize amongst themselves and provide the necessary locking. Multiple threads each manipulating a different `CertPathBuilder` instance need not synchronize.
Uses `CertUtil` to actualiy load the SPI classes.

See Also:
  `CertUtil`

Constructor Summary
`protected` | `CertPathBuilder(CertPathBuilderSpi builderSpi, java.security.Provider provider, java.lang.String algorithm)` Creates a CertPathBuilder object of the given algorithm, and encapsulates the given provider implementation (SPI object) in it.

Method Summary
`CertPathBuilderResult` | `build(CertPathParameters params)` Attempts to build a certification path using the specified algorithm parameter set.
`java.lang.String` | `getAlgorithm()` Returns the name of the algorithm of this `CertPathBuilder`.
`static java.lang.String` | `getDefaultType()` Returns the default `CertPathBuilder` type as specified in the Java security properties file, or the string "PKIX" if no such property exists.
`static CertPathBuilder` | `getInstance(java.lang.String algorithm)` Returns a CertPathBuilder object that implements the specified algorithm. If the default provider package provides an implementation of the specified CertPathBuilder algorithm, an instance of CertPathBuilder containing that implementation is returned.
`static CertPathBuilder` | `getInstance(java.lang.String algorithm, java.security.Provider provider)` Returns a CertPathBuilder object that implements the specified algorithm, as supplied by the specified provider.
`static CertPathBuilder` | `getInstance(java.lang.String algorithm, java.lang.String provider)` Returns a CertPathBuilder object that implements the specified algorithm, as supplied by the specified provider.
`java.security.Provider` | `getProvider()` Returns the provider of this `CertPathBuilder`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CertPathBuilder

    protected CertPathBuilder(CertPathBuilderSpi builderSpi,
                              java.security.Provider provider,
                              java.lang.String algorithm)

  Creates a CertPathBuilder object of the given algorithm, and encapsulates the given provider implementation (SPI object) in it.
  Parameters:
    `builderSpi` - the provider implementation
    `provider` - the provider
    `algorithm` - the algorithm name

Method Detail

### getInstance

    public static CertPathBuilder getInstance(java.lang.String algorithm)
                                       throws java.security.NoSuchAlgorithmException

  Returns a CertPathBuilder object that implements the specified algorithm.
  If the default provider package provides an implementation of the specified CertPathBuilder algorithm, an instance of CertPathBuilder containing that implementation is returned. If the requested algorithm is not available in the default package, other packages are searched.
  Parameters:
    `algorithm` - the name of the requested CertPathBuilder algorithm
  Returns:
    a CertPathBuilder object that implements the specified algorithm
  Throws:
    `java.security.NoSuchAlgorithmException` - if the requested algorithm is not available in the default provider package or any of the other provider packages that were searched

### getInstance

    public static CertPathBuilder getInstance(java.lang.String algorithm,
                                              java.lang.String provider)
                                       throws java.security.NoSuchAlgorithmException,
                                              java.security.NoSuchProviderException

  Returns a CertPathBuilder object that implements the specified algorithm, as supplied by the specified provider.
  Parameters:
    `algorithm` - the name of the requested CertPathBuilder algorithm
    `provider` - the name of the provider
  Returns:
    a CertPathBuilder object that implements the specified algorithm, as supplied by the specified provider
  Throws:
    `java.security.NoSuchAlgorithmException` - if the requested algorithm is not available from the specified provider
    `java.security.NoSuchProviderException` - if the provider has not been configured
    `java.lang.IllegalArgumentException` - if the provider is null

### getInstance

    public static CertPathBuilder getInstance(java.lang.String algorithm,
                                              java.security.Provider provider)
                                       throws java.security.NoSuchAlgorithmException

  Returns a CertPathBuilder object that implements the specified algorithm, as supplied by the specified provider. Note: the provider doesn't have to be registered.
  Parameters:
    `algorithm` - the name of the requested CertPathBuilder algorithm
    `provider` - the provider
  Returns:
    a CertPathBuilder object that implements the specified algorithm, as supplied by the specified provider
  Throws:
    `java.security.NoSuchAlgorithmException` - if the requested algorithm is not available from the specified provider
    `java.lang.IllegalArgumentException` - if the provider is null.

### getProvider

    public final java.security.Provider getProvider()

  Returns the provider of this `CertPathBuilder`.
  Returns:
    the provider of this `CertPathBuilder`

### getAlgorithm

    public final java.lang.String getAlgorithm()

  Returns the name of the algorithm of this `CertPathBuilder`.
  Returns:
    the name of the algorithm of this `CertPathBuilder`

### build

    public final CertPathBuilderResult build(CertPathParameters params)
                                      throws CertPathBuilderException,
                                             java.security.InvalidAlgorithmParameterException

  Attempts to build a certification path using the specified algorithm parameter set.
  Parameters:
    `params` - the algorithm parameters
  Returns:
    the result of the build algorithm
  Throws:
    `CertPathBuilderException` - if the builder is unable to construct a certification path that satisfies the specified parameters
    `java.security.InvalidAlgorithmParameterException` - if the specified parameters * are inappropriate for this `CertPathBuilder`

### getDefaultType

    public static final java.lang.String getDefaultType()

  Returns the default `CertPathBuilder` type as specified in the Java security properties file, or the string "PKIX" if no such property exists. The Java security properties file is located in the file named <JAVA_HOME>/lib/security/java.security, where <JAVA_HOME> refers to the directory where the SDK was installed.
  The default `CertPathBuilder` type can be used by applications that do not want to use a hard-coded type when calling one of the `getInstance` methods, and want to provide a default type in case a user does not specify its own.
  The default `CertPathBuilder` type can be changed by setting the value of the "certpathbuilder.type" security property (in the Java security properties file) to the desired type.
  Returns:
    the default `CertPathBuilder` type as specified in the Java security properties file, or the string "PKIX" if no such property exists.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.21
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD